import pygame, data
from pygame.locals import *
from collections import namedtuple
from euclid import Vector2

SIZE = WIDTH, HEIGHT = 800, 600
FPS = 30

MOUSEPOS = [0, 0]
SOUNDCOUNT = 0

M_1 = 1000
M_2 = 1001
M_3 = 1002
KEYS = {
  K_LEFT :  1 << 0,
  K_a    :  1 << 0,
  K_RIGHT:  1 << 1,
  K_d    :  1 << 1,
  K_UP   :  1 << 2,
  K_SPACE:  1 << 2,
  K_w    :  1 << 2,
  M_1    :  1 << 3,
  M_3    :  1 << 4,
}

# fix this - maybe this (monkeesage): http://www.velocityreviews.com/forums/t373406-does-python-provide-struct-data-structure.html
DIR = namedtuple('Directions', ['left', 'right', 'up', 'down'])
DIR.left  = Vector2( -1,  0)
DIR.right = Vector2(  1,  0)
DIR.up    = Vector2(  0, -1)
DIR.down  = Vector2(  0,  1)
GRAVITY = DIR.down * 1.3 # g = 1.3

PLAYERS   = pygame.sprite.RenderUpdates()
HUMANS    = pygame.sprite.RenderUpdates()
MUTATORS  = pygame.sprite.RenderUpdates()
UNMUTATORS= pygame.sprite.RenderUpdates()
MUTANTS   = pygame.sprite.RenderUpdates()
MISC      = pygame.sprite.RenderUpdates()
DEAD      = pygame.sprite.RenderUpdates()
FOUREYES  = pygame.sprite.RenderUpdates()
ALLGROUPS = [ PLAYERS, HUMANS, MUTATORS, UNMUTATORS, MUTANTS, MISC, DEAD, FOUREYES ]

# a necessary evil, because I need BG and BGIA to be available everywhere
pygame.init()
SCREEN = pygame.display.set_mode(SIZE)
SCREENRECT = SCREEN.get_rect()


XOFF = YOFF = 50
BG = pygame.Surface(SIZE).convert()
BGIR = BG.get_rect().move(-XOFF,-YOFF)
BGIA = None #pygame.surfarray.array_alpha(BG)
